#!/usr/bin/perl -w

#
# Hinweise zur Nutzung und Copyright erhalten Sie mit "perldoc quota.cgi".
# Abbruch/Ende von perldoc mit q (wie "quit")
#

# ------------- Konfigurationsbereich ---------------------------------------


# hier kann das Aussehen der Seite modifiziert werden. Alles zwischen der
# Zeile "$kopf = <<header;" und der Zeile "header" ist reines HTML und kann
# nach eigenem Gutduenken geaendert werden, also auch Bilder, CSS-Datei u.a.m
#
$kopf = <<header;
<html>
<head>
<title>Quota-Ueberschreitung</title>
</head>
<body background=whttxtr2.jpg>
<h1 align=center>Auflistung, wessen Quotas &uuml;berschritten wurden</h2>
<hr>
header


# hier können die Tabellen, also die eigentlichen Inhalte, in gewissen Grenzen
# modifiziert werden. Sie können von den Feldern:
#   User - verwendeter Speicherplatz - Softlimit - Hardlimit - Grace period -
#   Anzahl Dateien - Softlimit - Hardlimit - Grace period
# jedes der letzten 7 ausblenden. Ist die Variable auf 1 gesetzt, wird die
# Spalte angezeigt, bei 0 wird diese ausgeblendet
$Softlimit_1   = 0;                            # Softlimit des Festplattenplatzes
$Hardlimit_1   = 0;                            # Hardlimit des Festplattenplatzes
$GracePeriod_1 = 1;                            # wieviel Tage noch
$AnzahlDateien = 1;                            # Anzahl der vorhandenen Dateien
$Softlimit_2   = 0;                            # Softlimit dieser Anzahl
$Hardlimit_2   = 0;                            # Hardlimit dieser Anzahl
$GracePeriod_2 = 1;                            # wieviel Tage noch


# hier kann das Aussehen der Fußzeile modifiziert werden. $kopf und $fuss
# zusammen (also nur das HTML) bilden eine komplette Seite aber ohne Inhalt.
#
$fuss = <<foot;
<br>
<hr>
<a href=\"index.htm\" target=_top><img src=\"back.gif\" border=0> Zur&uuml;ck </a><br>
<address>&copy; HD. Kirmse, 15.06.2004</address>
Zuletzt ge&auml;ndert am : 26.09.2004 J&ouml;rg Fiebig 
</body>
</html>
foot


# ------------- Programm ----------------------------------------------

# wir holen uns erstmal die Daten
@daten = `/usr/sbin/repquota -avug`;         # unter UserID laufen lassen

# zum entwickeln und testen (auch unter Windows), dann auskommentieren
# open(DATEI,'<quota.txt')  or die ;
# @daten = <DATEI>;
# close (DATEI);

# Wir setzen ein Flag, um die verschiedenen Listen zu steuern
$flag   = 1;


# fuer jede Zeile von @daten
foreach $zeile (@daten) {

  # fuer die erste Partition
  if ($flag == 1) {

    # wenn die Zeile am Anfang "*** Report for" enthaelt, holen wir die Partition
    if ($zeile =~ m/^\*\*\* Report for.* (\/dev\/.*)/i) {
      $partition1 = $1;
    }
    # wenn es eine "relevante" Datenzeile ist (mindestens ein "+"), dann speichern
    elsif ($zeile =~ m/^\w+\s*.?\+/i) {
      push @liste1, $zeile;
    }
    # wenn eine Leerzeile, dann naechste Tabelle, also $flag = 2
    elsif ($zeile =~ m/^\s*$/i) {
      $flag = 2
    }
  }

  # fuer die zweite Partition
  if ($flag == 2) {

    # wenn die Zeile am Anfang "*** Report for" enthaelt, holen wir die Partition
    if ($zeile =~ m/^\*\*\* Report for.* (\/dev\/.*)/i) {
      $partition2 = $1;
    }
    # wenn es eine "relevante" Datenzeile ist (mindestens ein "+"), dann speichern
    elsif ($zeile =~ m/^\w+\s*.?\+/i) {
      push @liste2, $zeile;
    }
  }
}


# jetzt werden beide Listen alphabetisch sortiert
@liste1 = sort @liste1;
@liste2 = sort @liste2;


# zur Formatierung der Ausgabe wird die Anzahl der Spalten gezaehlt
$spalten = &bestimmeAnzahlSpalten;


# Erstellen der ersten Tabelle
$tabelle1  = &schreibeUeberschrift($partition1);
$tabelle1 .= &baueTabelle(@liste1);
$tabelle1 .= '</table><br>'."\n";


# Erstellen der zweiten Tabelle
$tabelle2  = &schreibeUeberschrift($partition2);
$tabelle2 .= &baueTabelle(@liste2);
$tabelle2 .= '</table><br>'."\n";


# jetzt wird die Webseite auf der Standardausgabe ausgegeben
print "Content-type: text/html\n\n";
print $kopf;
print $tabelle1;
print $tabelle2;
print $fuss;

# Programmende


# ------------- Prozeduren --------------------------------------------


sub verwendeter_platz_von_var
{
  # open(DATEI,'<df.txt') or die;
  # @temp = <DATEI>;
  # close (DATEI);

  @temp = `/bin/df`;

  foreach $zeile (@temp) {
    if ($zeile =~ /\s+(\d+%)\s+\/var$/) {
       $used = $1
    }
  }

  return $used
}



sub verwendeter_platz_von_home
{
  # open(DATEI,'<df.txt') or die;
  # @temp = <DATEI>;
  # close (DATEI);

  @temp = `/bin/df`;

  foreach $zeile (@temp) {
    if ($zeile =~ /\s+(\d+%)\s+\/home$/) {
       $used = $1
    }
  }

  return $used
}



sub bestimmeAnzahlSpalten
{
  my $elemente = 2;
  if ($Softlimit_1   == 1){ $elemente++; };    # Softlimit von Plattenplatz
  if ($Hardlimit_1   == 1){ $elemente++; };    # Hardlimit von Plattenplatz
  if ($GracePeriod_1 == 1){ $elemente++; };    # Grace period von Plattenplatz
  if ($AnzahlDateien == 1){ $elemente++; };    # Anzahl der Dateien
  if ($Softlimit_2   == 1){ $elemente++; };    # Softlimit von Anzahl der Dateien
  if ($Hardlimit_2   == 1){ $elemente++; };    # Hardlimit von Anzahl der Dateien
  if ($GracePeriod_2 == 1){ $elemente++; };    # Grace period von Anzahl Dateien

  return $elemente;
}


sub schreibeUeberschrift
{
  my $part = $_[0] ;
  my $ueberschr = '';

  $platz = '';

  if ($part  =~ /var/) {
     $platz  = ' &nbsp; - ';
     $platz .= &verwendeter_platz_von_var;
     $platz .= ' der Partition belegt';
  }
  if ($part  =~ /home/) {
     $platz  = ' &nbsp; - ';
     $platz .= &verwendeter_platz_von_home;
     $platz .= ' der Partition belegt';
  }


  $ueberschr .= '<h3><font color="#A0A0A0">Quotas f&uuml;r Device '.$part.$platz.'</font></h3>';
  $ueberschr .= "\n".'<table border="1" width="100%">'."\n".'<tr>'."\n";
  $breite     = int( 200 / $spalten );
  $ueberschr .= ' <th width="'.$breite.'%">User</th>';
  $ueberschr .= '<th>&nbsp;&nbsp;kByte&nbsp;&nbsp;</th>';
  if ($Softlimit_1   == 1){ $ueberschr .= '<th>Softlimit</th>'};
  if ($Hardlimit_1   == 1){ $ueberschr .= '<th>Hardlimit</th>'};
  if ($GracePeriod_1 == 1){ $ueberschr .= '<th>Grace&nbsp;period</th>'};
  if ($AnzahlDateien == 1){ $ueberschr .= '<th>Dateien</th>'};
  if ($Softlimit_2   == 1){ $ueberschr .= '<th>Softlimit</th>'};
  if ($Hardlimit_2   == 1){ $ueberschr .= '<th>Hardlimit</th>'};
  if ($GracePeriod_2 == 1){ $ueberschr .= '<th>Grace&nbsp;period</th>'};
  $ueberschr .= "\n".'</tr>'."\n";

  return $ueberschr;
}

sub baueTabelle
{
  my @liste   = @_;
  my $tabelle = '';

  my $anzahl  = @liste;
  if ($anzahl != 0) {

    # fuer jede Zeile von @liste
    foreach $zeile (@liste) {

      # wir holen uns die einzelnen Elemente fuer die Tabelle
      $zeile =~ m/^                            # am Anfang
                 (\w+)                         # mindestens ein Buchstabe (Login) $1
                  \s*                          # keins oder mehrere Whitespace
                 ([-|+])                       # ein + oder ein -                 $2
                 ([-|+])                       # ein + oder ein -                 $3
                  \s+                          # mindestens ein Whitespace
                 (\d+)                         # mindestens eine Ziffern          $4
                  \s+                          # mindestens ein Whitespace
                 (\d+)                         # mindestens eine Ziffern          $5
                  \s+                          # mindestens ein Whitespace
                 (\d+)                         # mindestens eine Ziffern          $6
                  \s+                          # mindestens ein Whitespace
                 ([\w|:]*)                     # keins, mehrere Buchstaben, ":"   $7
                  \s+                          # mindestens ein Whitespace
                 (\d+)                         # mindestens eine Ziffern          $8
                  \s+                          # mindestens ein Whitespace
                 (\d+)                         # mindestens eine Ziffern          $9
                  \s+                          # mindestens ein Whitespace
                 (\d+)                         # mindestens eine Ziffern          $10
                  \s+                          # mindestens ein Whitespace
                 ([\w|:]*)                     # keins, mehrere Buchstaben, ":"   $11
                      /ix ;                    # i = ignoriere Gro- / Kleinschreibung
                                               # x = Kommentare im reg. Ausdr. erlaubt

      my $temp1 = $7;                          # hier geht es nur darum, dass leere
      my $temp2 = $11;                         # Tabellenzellen trotzdem richtig
      if ($temp1 eq '') { $temp1 = '&nbsp;' }; # gezeichnet werden -> &nbsp;
      if ($temp2 eq '') { $temp2 = '&nbsp;' };

      # alle Logins, bei denen nichts mehr geht, sind rot hervorgehoben
      my $account = $1;
      if ($temp1 eq 'none' or $temp2 eq 'none') {
        $account = '<font color="#FF0000">'.$account.'</font>';
      }

      $tabelle  .= '<tr><td>'.$account.'</td>';
      $tabelle  .= '<td>'.$4.'</td>';
      if ($Softlimit_1  ==1){$tabelle .= '<td><font color="#A0A0A0">'.$5.'</font></td>'};
      if ($Hardlimit_1  ==1){$tabelle .= '<td><font color="#A0A0A0">'.$6.'</font></td>'};
      if ($GracePeriod_1==1){$tabelle .= '<td>'.$temp1.'</td>'};
      if ($AnzahlDateien==1){$tabelle .= '<td>'.$8.'</td>'};
      if ($Softlimit_2  ==1){$tabelle .= '<td><font color="#A0A0A0">'.$9.'</font></td>'};
      if ($Hardlimit_2  ==1){$tabelle .= '<td><font color="#A0A0A0">'.$10.'</font></td>'};
      if ($GracePeriod_2==1){$tabelle .= '<td>'.$temp2.'</td>'};
      $tabelle  .= '</tr>'."\n";
    }

  } else {

    $tabelle .= '<tr><td colspan='.$spalten;
    $tabelle .= '> Softlimit wurde von keinem User &uuml;berschritten';
    $tabelle .= '</td></tr>'."\n";
  }

  return $tabelle;
}


__END__


=head1 NAME

quota.cgi - erstellt Webseite der User, die Softlimit ueberschritten haben


=head1 SYNOPSIS

http://www/online/quota.cgi


=head1 COPYRIGHT

Dieses Script unterliegt der GPL.


=head1 INSTALLATION

bei repquota muß unbedingt dafuer gesorgt werden, dass dieses
unter der UID des Besitzers (also root) laeuft.



=head1 BESCHREIBUNG

Dieses CGI-Script listet alle User auf, bei denen Quotas gesetzt sind und
deren Softlimit ueberschritten ist.

Dabei wird fuer jede Partition eine Tabelle erstellt mit den folgenden Spalten:
"User" - "verwendeter Speicherplatz" - "Softlimit" - "Hardlimit" - "Grace period" -
"Anzahl Dateien" - "Softlimit" - "Hardlimit" - "Grace period".

Bis auf die ersten beiden Spalten koennen durch die Konfiguration alle anderen
Spalten beliebig ausgeblendet werden. Ebenso laesst sich im Konfigurationsbereich
leicht das Layout der Seite aendern.

Bei Accounts, bei denen die "Grace period" abgelaufen ist werden die Logins
rot angezeigt.

Sollten keine Quota-Ueberschreitungen vorliegen, wird in der Tabelle angegeben:
"Softlimit wurde von keinem User ueberschritten".


=head1 AUTOR

Hans-Dietrich Kirmse <hd.kirmse@gmx.de>,
Lehrer am Erasmus-Reinhold-Gymnasium Saalfeld Thueringen


=cut